<?php

class AQ_Product_Category_Block extends AQ_Block {
	
	//set and create block
	function __construct() {
		$block_options = array(
			'name' => 'Shop page',
			'size' => 'span12',
			'resizable' => 1,
			'icon' => 'fa-shopping-cart',
			'icon_color' => 'FFF',
			'category' => 'Ecommerce',
			'help' => 'Block that adds products to the page.'
			
		);
		
		//create the block
		parent::__construct('aq_product_category_block', $block_options);
	}
	
	function form($instance) {
		$product_categories_default = ($temp = get_terms('product_cat')) ? $temp : array();
		$product_options_default = array();
		$i = 0;
		foreach($product_categories_default as $cat_default) {
			$product_options_default[$i++] = $cat_default->term_id;
		}	
				
		$defaults = array(
			'number_product' => '12',
			'rows_product' => '4',
			'product_order' => 'desc',
			'product_sort_by' => 'date',			
			'categories_product' => $product_options_default,
			'show_sorting' => 1,
			'show_navigation' => 1,
		);
		
		$order_options = array(
			'asc' => 'ASC',
			'desc' => 'DESC',
		);
		
		$sort_by_options = array(
			'menu_order' => 'Default',	
			'date' => 'Date',
			'title' => 'Title',	
		);
		
		$product_column_options = array(
			'1' => 'One column',
			'2' => 'Two columns',
			'3' => 'Three columns',
			'4' => 'Four columns',			
			'5' => 'Five columns',
			'6' => 'Six columns',			
		);	
		
		$instance = wp_parse_args($instance, $defaults);
		extract($instance);
		if (pmc_woo() && PMC_SHOP){ 
			$product_categories = ($temp = get_terms('product_cat')) ? $temp : array();
			$categories_options = array();
			foreach($product_categories as $cat) {
				$categories_options[$cat->term_id] = $cat->name;
			}

			?>
			<p class="description note">
				<?php _e('Use this block to create product block.', 'pmc-themes') ?>
			</p>	
			<p class="description half ">
				<label for="<?php echo $this->get_field_id('categories_product') ?>" style="width:100%;float: left;margin-bottom: 10px;">
				Product Category<br/>
				<?php echo aq_field_multiselect('categories_product', $block_id, $categories_options, $categories_product); ?>
				</label>			
				<label for="<?php echo $this->get_field_id('number_product') ?>" style="width:100%;float: left;margin-bottom: 10px;">
					Number of product to show<br>
					<?php echo aq_field_input('number_product', $block_id, $number_product, $size = 'big') ?>
				</label>
				<label for="<?php echo $this->get_field_id('product_order') ?>">
					Number of columns<br/>
					<?php echo aq_field_select('rows_product', $block_id, $product_column_options, $rows_product); ?>
				</label>	

			</p>

			<p class="description half last">		
				<label for="<?php echo $this->get_field_id('product_order') ?>">
					Products order<br/>
					<?php echo aq_field_select('product_order', $block_id, $order_options, $product_order); ?>
				</label>				
				<label for="<?php echo $this->get_field_id('product_sort_by') ?>" style="width:100%;float: left;margin-bottom: 10px;">
					Products order<br/>
					<?php echo aq_field_select('product_sort_by', $block_id, $sort_by_options, $product_sort_by); ?>
				</label>
				<label for="<?php echo $this->get_field_id('show_navigation') ?>" style="width:100%;float: left;margin-bottom: 10px;">
					<?php echo aq_field_checkbox('show_navigation', $block_id, $show_navigation); ?>
					Show navigation?
				</label>
				<label for="<?php echo $this->get_field_id('show_sorting') ?>" style="width:100%;float: left;margin-bottom: 10px;">
					<?php echo aq_field_checkbox('show_sorting', $block_id, $show_sorting); ?>
					Show sorting?
				</label>				
				
			</p>		
			

			<?php
		}		
	}
	
	function block($instance) {
		
		if (pmc_woo() && PMC_SHOP){ 
		
			
			$defaults = array(
				'number_product' => '12',
				'rows_product' => '4',
				'product_order' => 'asc',
				'product_sort_by' => 'menu_order',			
				'categories_product' => '',
				'show_sorting' => 1,
				'show_navigation' => 1,
			);
			

			$instance = wp_parse_args($instance, $defaults);	
			extract($instance);
			

			$product_categories_default = ($temp = get_terms('product_cat')) ? $temp : array();
			$product_options_default = array();
			$i = 0;
			foreach($product_categories_default as $cat_default) {
				$product_options_default[$i++] = $cat_default->term_id;
			}			

			If(empty($categories_product)){	
				$categories_product = $product_options_default;
			}			

			$isinarray = true;
			foreach($categories_product as $cat_saved){
				
				if(array_search($cat_saved,$product_options_default) === false){
						$isinarray = false;
					}
				if($isinarray == false){
					$categories_product = null;
					break; 
				}
				
			}
			
			if(empty($categories_product)){
				$categories_product = $product_options_default;
			}			
			
			if(isset($show_sorting)){
				$navigation = 'paginate="true"'; } else {$navigation = '';}
			
			$filtered_posts = array();
			?>
			
			<?php 
			if(!defined('SHOP_ROWS')) define( 'SHOP_ROWS', intval($rows_product) );
			
			/* set number of rows*/
			add_filter('loop_shop_columns', 'loop_columns');
			
			if (!function_exists('loop_columns')) {
				function loop_columns() {
					return SHOP_ROWS; 
				}
			}
			$term = array();
			foreach($categories_product as $key=>$cat){
				 $term_query = get_term_by('id', $cat, 'product_cat', 'ARRAY_A');
				 $term[$key] = $term_query['slug'];
			}
			
			$category = implode(", ",$term);
			echo do_shortcode('[products '.$navigation.' limit="'.$number_product.'" columns="'.$rows_product.'" category="'.$category.'" cat_operator="IN" orderby="'.$product_sort_by.'" order="'.$product_order.'"]');

			

		}
	}
	
	function update($new_instance, $old_instance) {
		$new_instance = aq_recursive_sanitize($new_instance);
		return $new_instance;
	}

}